[![Build Status](https://travis-ci.org/AnaelFavre/node-redis-embed.png?branch=master)](https://travis-ci.org/AnaelFavre/node-redis-embed)

node-redis-embed - Redis embedding package for Node
===========================

This package allow you to run Redis into your node application. The redis-server will be started and stopped with your node app.

Install with this package :
- [redis](https://github.com/mranney/node_redis) (raw client for using the database)
- [redis-commander](https://github.com/nearinfinity/redis-commander) (a web based database visualisation for debbuging).

## Install

    npm install node-redis-embed

Or from source:

    git clone git://github.com/anaelfavre/node-redis-embed.git 
    cd node-redis-embed
    npm link

![:warning:](http://www.xn--anal-npa.com/famfamfam/error.png "Warning") You **SHOULD** install Redis Server before using `node-redis-embed`. Go to [Redis download and installation page](http://redis.io/download)

## How to use

Just require the module and create a new redis server instance.

```javascript
var redisembed = require('node-redis-embed');
var redis = redisembed.createServer();
```

By calling `createServer()` function you will start and configure a new instance of redis-server.

### Start and Stop

When you node app started a new redis-server instance, the main process events [exit](http://nodejs.org/api/process.html#process_event_exit)/[SIGINT](http://nodejs.org/api/process.html#process_signal_events) are listened for stopping the server when your app stops. 

However, if your app exit violently by throwing an error your program will kill itself without stopping the server. That's why on each createServer() call, `node-redis-embed` check if there are already a redis-server process (by using `pidof -s redis-server`) and try to stop it properly before starting it again.

## LICENSE - "MIT License"

Copyright (c) 2013 Anael Favre, [http://www.anaël.com/](http://www.xn--anal-npa.com)

Permission is hereby granted, free of charge, to any person
obtaining a copy of this software and associated documentation
files (the "Software"), to deal in the Software without
restriction, including without limitation the rights to use,
copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the
Software is furnished to do so, subject to the following
conditions:

The above copyright notice and this permission notice shall be
included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
OTHER DEALINGS IN THE SOFTWARE.